﻿Imports GrapeCity.Windows.SpreadSheet.Data



Partial Public Class MainPage
    Inherits UserControl
    Dim cmenu As ContextMenu
    Dim mItem As MenuItem

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub UserControl_Loaded(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        GcSpreadSheet1.ActiveSheet.Cells(0, 0, 3, 3).Text = "test"
    End Sub
    Private Function GetActualCellRange(cellRange As GrapeCity.Windows.SpreadSheet.Data.CellRange, rowCount As Integer, columnCount As Integer) As CellRange
        If cellRange.Row = -1 AndAlso cellRange.Column = -1 Then
            Return New CellRange(0, 0, rowCount, columnCount)
        ElseIf cellRange.Row = -1 Then
            Return New CellRange(0, cellRange.Column, rowCount, cellRange.ColumnCount)
        ElseIf cellRange.Column = -1 Then
            Return New CellRange(cellRange.Row, 0, cellRange.RowCount, columnCount)
        End If

        Return cellRange
    End Function

    Private Sub GcSpreadSheet1_MouseRightButtonDown(sender As Object, e As System.Windows.Input.MouseButtonEventArgs) Handles GcSpreadSheet1.MouseRightButtonDown
        e.Handled = True

        cmenu = New ContextMenu()
        mItem = New MenuItem()
        mItem.Header = "Number Cell"
        cmenu.Items.Add(mItem)
        AddHandler mItem.Click, AddressOf mItem_Click



        mItem = New MenuItem()
        mItem.Header = "Date Cell"
        cmenu.Items.Add(mItem)
        AddHandler mItem.Click, AddressOf mItem_Click

        mItem = New MenuItem()
        mItem.Header = "Cut"
        cmenu.Items.Add(mItem)
        AddHandler mItem.Click, AddressOf mItem_Click

        mItem = New MenuItem()
        mItem.Header = "Copy"
        cmenu.Items.Add(mItem)
        AddHandler mItem.Click, AddressOf mItem_Click

        mItem = New MenuItem()
        mItem.Header = "Paste"
        cmenu.Items.Add(mItem)
        AddHandler mItem.Click, AddressOf mItem_Click

        cmenu.IsOpen = True
        cmenu.HorizontalOffset = e.GetPosition(LayoutRoot).X
        cmenu.VerticalOffset = e.GetPosition(LayoutRoot).Y

    End Sub

    Public Sub mItem_Click(ByVal Sender As Object, ByVal e As RoutedEventArgs)
        Dim menuItem As MenuItem = DirectCast(Sender, MenuItem)
        Select Case menuItem.Header.ToString()
            Case "Number Cell"

                GcSpreadSheet1.ActiveSheet.ActiveCell.Formatter = New GrapeCity.Windows.SpreadSheet.Data.GeneralFormatter(GrapeCity.Windows.SpreadSheet.Data.FormatMode.StandardNumericMode, "c")
                Exit Select
            Case "Date Cell"
                GcSpreadSheet1.ActiveSheet.ActiveCell.Formatter = New GrapeCity.Windows.SpreadSheet.Data.GeneralFormatter(GrapeCity.Windows.SpreadSheet.Data.FormatMode.StandardDateTimeMode, "M")
                Exit Select
            Case "Cut"
                For Each cellRange As CellRange In GcSpreadSheet1.ActiveSheet.Selections
                    Dim range As CellRange = GetActualCellRange(cellRange, GcSpreadSheet1.ActiveSheet.RowCount, GcSpreadSheet1.ActiveSheet.ColumnCount)

                    GcSpreadSheet1.View.ClipboardCut(range)
                Next

                Exit Select
            Case "Copy"
                For Each cellRange As CellRange In GcSpreadSheet1.ActiveSheet.Selections
                    Dim range As CellRange = GetActualCellRange(cellRange, GcSpreadSheet1.ActiveSheet.RowCount, GcSpreadSheet1.ActiveSheet.ColumnCount)


                    GcSpreadSheet1.View.ClipboardCopy(range)
                Next

                Exit Select
            Case "Paste"
                For Each cellRange As CellRange In GcSpreadSheet1.ActiveSheet.Selections
                    Dim range As CellRange = GetActualCellRange(cellRange, GcSpreadSheet1.ActiveSheet.RowCount, GcSpreadSheet1.ActiveSheet.ColumnCount)
                    GcSpreadSheet1.View.ClipboardPaste(range)
                Next

                Exit Select
            Case Else
                Exit Select
        End Select
        cmenu.IsOpen = False

    End Sub
End Class